
      /*
       *  pbbench.cpp
       *
       *  Copyright (c) 2008 by Kuscsik Peter <kuscsikp@gmail.com>
       *
       *  This program is free software; you can redistributeprocs_online it and/or modify
       *  it under the terms of the GNU General Public License as published by
       *  the Free Software Foundation; either version 2 of the License, or
       *  (at your option) any later version.
       *
       *  This program is distributed in the hope that it will be useful,
       *  but WITHOUT ANY WARRANTY; without even the implied warranty of
       *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       *  GNU General Public License for more details.
       *
       *  You should have received a copy of the GNU General Public License
       *  along with this program; if not, write to the Free Software
       *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
       *  USA.
       */ 


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "sys/time.h"
#include <sys/times.h>

#include <dlfcn.h>
#include "bench/ctest.h"

int *PBBench(int arg);

long PBgetTickCount()
{
    tms tm;
    return times(&tm)*10;
}

void PBCpuBurn(int secs)
{
	printf("Waiting");	
	fflush(stdout);
	int step=0;
	unsigned long start = PBgetTickCount();
	while (PBgetTickCount()-start<secs*1000)
		if (step!=(PBgetTickCount()-start)/1000) {
			step=(PBgetTickCount()-start)/1000;
			printf(".");
			fflush(stdout);
			}

	printf("\n");	
}

int *PBBench(int arg) 
{
	void *lib_handle;
	int x;
	char *error;
	printf("\n------=[CPU Benchmarks]=----------------------------------------------\n");
	lib_handle = dlopen("libpbbench.so", RTLD_LAZY);
	if (!lib_handle) 
	{
		fprintf(stderr, "%s\n", dlerror());
		fprintf(stderr, "probably \"libpbbench.so\" file is missing\n", dlerror());
		return 0;
	}

	void (*fn)(int *);

	char* (*list)(int);
	list = (char* (*)(int)) dlsym(lib_handle, "ctbench");

	char* bc = (*list)(GET_COUNT);
	int count = *bc;

//	show_info();
//	
	if (arg==LIST_BENCHMARKS)
		for (int i = 1; i <= count; i++) 
			printf("%d. %s, %s\n", i, (*list)(i | SHORT_NAME), (*list)(i | LONG_NAME));

	if (arg==RUN_ALL_BENCHMARKS) {
		PBCpuBurn(10);
		for (int i = 1; i <= count; i++) {
			printf("%d. %s(%s)", i, (*list)(i | SHORT_NAME), (*list)(i | LONG_NAME));
			fn = (void (*)(int *)) dlsym(lib_handle, (*list)(i));
			unsigned long start = PBgetTickCount();
			(*fn)(&x);	
			unsigned long end =  PBgetTickCount()-start;
			printf(" : %d ms\n", (int)end );
			}
		}


	dlclose(lib_handle);
	return 0;
}
